

var EventName=raisedEvent.name;

if(EventName=="model_ready"){
    Property.load();
    WescoVars.initialize();
    var timer=timedevents.timers["TIMER_discoverAirboxes"];
    var parameter={};
    timedevents.call(timer.name,timer.id,timer.duration,parameter);

    airboxes.discover();

    try{
	cloudService.fetchNotificationList(notifications.createList);
    }
    catch(err){
	// report error,  no cloud activated
    }
    // starts timer for evaluation of ventilation schedules
    var timerBoost=timedevents.timers["TIMER_ventilationSchedule"];
    timedevents.callPeriodic(timerBoost.name,timerBoost.id,"FREQ=HOURLY;BYMINUTE=01");
    //timedevents.callPeriodic(timerBoost.name,timerBoost.id,"FREQ=MINUTELY");
    //
}else{
    var BigMode=WescoVars.get("Controller/BigModeState_current");
    var parameter = raisedEvent.parameter;
    var clusterID=WescoVars.get("Controller/ClusterID");


    /// Management of the FSM: BigMode

    switch(BigMode){
    case "Alarm":
	if (EventName=="wesco_stateChange"){
	    var statename=parameter.statename;
	    var state=parameter.state;

	    if(statename=="fire" && state=="inactive"){
		var previousState=WescoVars.get("Controller/BigModeState_previous");
		WescoVars.save("Controller/BigModeState_current",previousState,true); // switch to previous

		// before leaving the mode fire, reenable all
		// FSM. This is in case a lock was active before
		// entering the alarm state.
		tiny.writingDone();
		airboxes.unlockAllAirboxes();
	    }
	}
	break;
    case "Presence":
	var PresenceMode=WescoVars.get("Controller/PresenceState_current");
	switch(EventName){

	case "wesco_processedScene": // Absence mode exit condition
	    var Scene=parameter["sceneID"];
	    var groupID=parameter["groupID"];

	    if (Scene==76){ // If the FIRE scene is triggered
		WescoVars.save("Controller/BigModeState_current","Alarm",false); // switch to Alarm Mode
		WescoVars.save("Controller/BigModeState_previous","Presence",true);
	    }else if(Scene==72){ // if the "leave home" scene is called
		WescoVars.save("Controller/BigModeState_current","Absence",false); // switch to Absence Mode
		WescoVars.save("Controller/BigModeState_previous","Presence",true);

		//process scene () -> evaluate control rules
	    }
	    break;

	}//end switch(raisedEvent.name){


	break;
    case "Absence":
	switch(EventName){
	case "wesco_processedScene": // Absence mode exit condition
	    var Scene=parameter["sceneID"];
	    var groupID=parameter["groupID"];

	    if (Scene==76){ // If the FIRE scene is triggered
		WescoVars.save("Controller/BigModeState_current","Alarm",false); // switch to Alarm Mode
		WescoVars.save("Controller/BigModeState_previous","Absence",true);
	    }else if(Scene==71 || (groupID==10 || groupID==clusterID)){
		// if the "come home" scene is called or any scene in
		// the groups ventilation or in the clusterID
		WescoVars.save("Controller/BigModeState_current","Presence",false); // switch to Presence Mode
		WescoVars.save("Controller/BigModeState_previous","Absence",true);

		//process scene () -> evaluate control rules
	    }
	    break;

	}//end switch(raisedEvent.name){


	break;
    default:
	break;
    }
}
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
/// End of FSM BigMode

var BigMode_current=WescoVars.get("Controller/BigModeState_current");
debug("DEBUG","BigMode:"+BigMode_current);
debug("DEBUG","event;"+raisedEvent.name);


if(BigMode_current=="Absence" || BigMode_current=="Presence"){

    switch(EventName){

    case  timedevents.timers["TIMER_ventilationSchedule"].name:
	var PresenceMode=WescoVars.get("Controller/PresenceState_current");

	if(BigMode_current=="Absence"){
	    var level=processSchedule("Absence");	    // Absence Schedule

	}else if (PresenceMode=="Schedule"){
	    var level=processSchedule("Presence");	    // Presence Schedule
	}

	// if (level!==undefined) { ...
	// Evaluate the control rules

	debug("DEBUG","Boost:"+BigMode_current+";level:"+level);
	break;


	/////////////////////////////////////////////////////////////
	/////////////////////////////////////////////////////////////
	/////////////////////////////////////////////////////////////
	/////// Events indendent on the FSM state /////

    case  timedevents.timers["TIMER_discoverAirboxes"].name:
	var timerparameter={};
	timer=timedevents.timers["TIMER_checkFilterReplacement"];
	timedevents.call(timer.name,timer.id,timer.duration,timerparameter);

	readAirboxesConf();
	startAirboxes(0,"+100"); // wait 100s and then start the airboxes (scene,wait time in seconds)
	WescoVars.save("Controller/PropTreeReady","Ready",false); // mark the app as ready
	break;


    case timedevents.timers["TIMER_defer_DS_Action"].name:
	/*This mechanism doesn't implement a queue, only the last
	 * called command is executed. It the flag is busy and a new
	 * command arrives, this command is rescheduled for later
	 * execution. If while waiting, another command arrives, the
	 * former command is replaced by the latter*/

	var param=raisedEvent.parameter;
	var busy=WescoVars.get_create("Controller/writingInProgress",false,false);
	if (busy == false){
	    tiny.SendMultiple(param); // complete the deferred action
	}else if (busy == true){ // relaunch the timer, continues waiting until busy is false
	    timer=timedevents.timers["TIMER_defer_DS_Action"];
	    timedevents.call(timer.name,timer.id,timer.duration,param);
	}
	break;

    case timedevents.timers["TIMER_remove_busy_flag"].name:
	/*Timeout for resetting writingInProgress Flag*/
	debug("DEBUG","Remove BusyFlag");
	tiny.writingDone();
	break;


    case "wesco_UI":
	parseUICommand(raisedEvent.parameter);
	break;

    case "wesco_RegistersOpCompleted":
	// This event is raised after a reading operation has been completed.

	//debug("DEBUG",JSON.stringify(raisedEvent));
	// The UI can also subscribe to this event
	var args=JSON.parse(raisedEvent.parameter.Regs);
	var Dict=JSON.parse(raisedEvent.parameter.Dict);

	for(var i in args){
	    var Reg=args[i];
	    for (var Dev in Dict){
		var Path=Dict[String(Dev)].Path;
		var completed=Dict[String(Dev)].completed;
		var Value=parseInt(completed[i]);
		airboxes.updateVariables(Path,Reg,Value);
	    }
	}
	tiny.writingDone();
	break;

    case timedevents.timers["TIMER_MultipleRegAction_FSM"].name:
	debug("DEBUG","event;MultipleRegAction_FSM_Timer");
	var parameter = raisedEvent.parameter;
	tiny.SendMultiple(parameter); // relaunch the airbox writing FSM
	break;

    case timedevents.timers["TIMER_clearupAirboxError"].name:
	var parameter = raisedEvent.parameter;
	var dsuid = parameter['dsuid'];
	airboxes.removeError(dsuid,0,"Timer");
	break;


    case timedevents.timers["TIMER_sendPushNotification"].name:
	var parameter=raisedEvent.parameter;
	var Type=parameter['Type'];
	notifications.push(Type);
	break;


    case timedevents.timers["TIMER_checkFilterReplacement"].name:
	try{
	    cloudService.fetchNotificationList(notifications.createList);
	}
	catch(err){
	    // report error,  no cloud activated
	}
	if(airboxes.checkFilterReplacement()){
	    notifications.schedule("FilterReplacement");
	    notifications.sendEmailFilterReplacement();
	}

	// set the timer to verify the filter replacement next time
	var timer=timedevents.timers["TIMER_checkFilterReplacement"];
	var parameter={};
	timedevents.call(timer.name,timer.id,timer.duration,parameter);
	airboxes.discover();
	break;


    case "deviceStatusEvent":
	// asynchronous message from the airbox or the extraction hood
	// This message can be used for error notifications

	var dsuid = raisedEvent.source['dsuid'];
	var AirboxPath="Airboxes/Devices/"+dsuid;

	// The error flag is set at the removeError state machine when
	// an error is reported.  This flag can only be cleared up from
	// the UI.
	var errorCode=WescoVars.get_create(AirboxPath+"/errorCode",'None',false);
	var errorFSMState=WescoVars.get_create(AirboxPath+"/errorFSMState","ready",true);
	var statusIndex=raisedEvent.parameter.statusIndex;
	var statusValue=raisedEvent.parameter.statusValue;

	if (airboxes.isAirbox(dsuid)){ // check if the source is an airbox
	    if (statusValue >= AIRBOX_POWER_ERR){
		if (errorCode===undefined || errorCode==ErrorCodes["no_error"]){
		    if (statusIndex==AIRBOX_ERROR_EVENT_STATUS_INDEX){
			// Call the airbox error routine
			airboxes.removeError(dsuid,statusValue,"errorEvent");
		    }
		}
	    }else if (statusValue == 7){ //initialization event

		var AirboxID=raisedEvent.source['dsid'];
		var PropTreeReady=WescoVars.get("Controller/PropTreeReady");

		if (PropTreeReady=="Ready"){

		    // Verify first that the device is not in the error state.

		    //airboxes.callLastScene(AirboxID);
		}
	    }
	}// end ...if (airboxes.isAirbox(dsuid)){ // check if the source is an airbox
	break;

    default:
	break;
    } // end ... switch(raisedEvent.name){
} // end ...if(BigMode=="Absence" || BigMode=="Presence"){





/// Function definiton

function startAirboxes(SceneNum,waitTime){
    var parameter={};
    var Dict={};
    var scenen=[SceneNum];
    parameter['action']='sendScene';
    parameter['path_toDevices']='Airboxes/Devices/'
    parameter['args']=JSON.stringify(scenen);
    parameter['FSMState']="initialize";
    parameter['Dict']=JSON.stringify(Dict);

    var timer=timedevents.timers["TIMER_defer_DS_Action"];
    timedevents.call(timer.name,timer.id+"_initialization",waitTime,parameter);
}

function readAirboxesConf(){
    /*Starts an operation reading registers 0 (error), 13-15 (level
     * 1-3) in all airboxes*/
    var parameter={};
    var Dict={};
    parameter['action']='readAll';
    parameter['path_toDevices']='Airboxes/Devices/'
    parameter['args']=JSON.stringify([0,13,14,15]);
    parameter['FSMState']="initialize";
    parameter['Dict']=JSON.stringify(Dict);
    tiny.SendMultiple(parameter);
}

function processSchedule(mode){ // Zeitplan Evaluation
    var d=new Date();
    var day=d.getDay(); // 0: Sunday ... 6: Saturday
    var hour=parseInt(d.getHours()); // 0 ... 23

    var schedule=WescoVars.get("Controller/VentilationSchedule/"+day);
    var ret=undefined;

    if (schedule!==undefined && schedule!==null){ // if there is an entrance for that particular day
	schedule=JSON.parse(schedule);
	for (var i in schedule){
	    if (parseInt(i)==hour){
		if (mode=='Presence'){
		    ret=schedule[i][0];
		}else if (mode=='Absence'){
		    ret=schedule[i][1];
		}
	    }
	}
    }else if (day >=1 && day <=5){ // if a weekday (1: Monday, 5: Friday)
	schedule=WescoVars.get("Controller/VentilationSchedule/7"); // weekday
	if (schedule!==undefined && schedule!==null){
	    schedule=JSON.parse(schedule);
	    for (var i in schedule){
		if (parseInt(i)==hour){
		    if (mode=='Presence'){
			ret= schedule[i][0];
		    }else if (mode=='Absence'){
			ret= schedule[i][1];
		    }
		}
	    }
	}
    }else if (day==0 || day==6){ // if a weekend (0: Sunday, 6: Saturday)
	schedule=WescoVars.get("Controller/VentilationSchedule/8"); //weekend
	if (schedule!==undefined && schedule!==null){
	    schedule=JSON.parse(schedule);
	    for (var i in schedule){
		if (parseInt(i)==hour){
		    if (mode=='Presence'){
			ret= schedule[i][0];
		    }else if (mode=='Absence'){
			ret= schedule[i][1];
		    }
		}
	    }
	}
    }// end if (day==0 || day==6){ // if a weekend{

    return ret;
}
